# Find the METIS library
# METIS will be used as graph partitioner 

# Find METIS include directory
FIND_PATH(METIS_INCLUDE_DIR metis.h PATH /usr/include 
                                         /usr/local/include 
                                         /usr/include/metis
                                         /usr/local/include/metis)
MESSAGE(${METIS_INCLUDE_DIR})

# Find METIS library
FIND_LIBRARY(METIS_LIBRARY metis PATH /usr/local/lib
				                      /usr/lib)

# Set found status
SET(METIS_FOUND_FLAG 1)

IF(METIS_INCLUDE_DIR)
    MESSAGE ("-- Found METIS include dir: " ${METIS_INCLUDE_DIR})
ELSE (METIS_INCLUDE_DIR)
    SET(METIS_FOUND_FLAG 0)
    MESSAGE("-- Could not find METIS include directory in the default locations. You can manually set the METIS_INCLUDE_DIR variable "
            "to the full path of the METIS include folder, using the option -DMETIS_INCLUDE_DIR=/path/to/dir/of/metis.h")
ENDIF(METIS_INCLUDE_DIR)

IF(METIS_LIBRARY)
    MESSAGE ("-- Found METIS library: " ${METIS_LIBRARY})
ELSE(METIS_LIBRARY)
    SET(METIS_FOUND_FLAG 0)
    MESSAGE("-- Could not find METIS library file in the default locations. You can manually set the METIS_LIBRARY variable "
            "to the full path of the libmetis.a library file, using the option -DMETIS_LIBRARY=/path/to/libmetis.a")
ENDIF(METIS_LIBRARY)

