#! /usr/bin/env sh

if [ $# -ne 1 ]; then 
	echo "Usage: bench_blas1_all COMPUTER_NAME";
        exit 1;
fi

# Parameters
UPPER_BOUND=10985760
TRIALS=100
ARCH=$1
OPTS=--no-cpu-qdouble

# Programs
BLAS1_SP=src/bench_blas1
BLASX1_SP=src/bench_blasx1
BLAS1_MP=src/bench_blas1_mp
BLASX1_MP=src/bench_blasx1_mp

# Clear results
rm -r $ARCH

# Make dirs for SP, MP
mkdir $ARCH
mkdir $ARCH/SP
mkdir $ARCH/MP

# Run SP test
for OP in DOT AXPY AYPX SCAL COPY 
do
   echo Running: $BLAS1_SP $OP -u $((1*$UPPER_BOUND)) -o $ARCH/SP/bench_$OP.result.csv $OPTS
   $BLAS1_SP $OP -u $((1*$UPPER_BOUND)) -o $ARCH/SP/bench_$OP.result.csv $OPTS
done
for OP in PWPR
do
   echo Running: $BLASX1_SP $OP -u $((1*$UPPER_BOUND)) -o $ARCH/SP/bench_$OP.result.csv $OPTS
   $BLASX1_SP $OP -u $((1*$UPPER_BOUND)) -o $ARCH/SP/bench_$OP.result.csv $OPTS
done

# Run MP tests, from 1 to 8
for NP in 1 2 3 4 5 6 7 8
do
  mkdir $ARCH/MP/$NP
  for OP in DOT AXPY AYPX SCAL COPY
  do
     echo Running: $BLAS1_MP $OP -u $(($NP*$UPPER_BOUND)) -p $NP -o $ARCH/MP/$NP/bench_$OP.result.csv $OPTS --no-gpu
     $BLAS1_MP $OP -u $(($NP*$UPPER_BOUND)) -p $NP -o $ARCH/MP/$NP/bench_$OP.result.csv $OPTS --no-gpu
  done
  for OP in PWPR
  do
     echo Running: $BLASX1_MP $OP -u $(($NP*$UPPER_BOUND)) -p $NP -o $ARCH/MP/$NP/bench_$OP.result.csv $OPTS --no-gpu
     $BLASX1_MP $OP -u $(($NP*$UPPER_BOUND)) -p $NP -o $ARCH/MP/$NP/bench_$OP.result.csv $OPTS --no-gpu
  done
done
