/*
 *  kernel_saypx.cl
 *  
 *
 *
 */
 
#pragma OPENCL EXTENSION cl_khr_fp64 : enable

__kernel void kernel_daypx(
		const int n,  
		const double a,
		__global const double* x,
		__global double* y,
		__local double* buffer_x,
		__local double* buffer_y
)
{
	// Starting point for this block
	int ctaStart = get_group_id(0) * get_local_size(0);
	 
	// Total no. of threads in the kernel
	int totalThreads = get_global_size(0);
	
	// Get current thread
	int tx = get_local_id(0); 
	
	// Read the data (full lines)
	for (int i = ctaStart + tx; i < n; i += totalThreads)
	{  
		// Prefetch x and y
		buffer_x[tx] = x[i];
		buffer_y[tx] = y[i];
		
		
		// Multiply and write 	 
		y[i] = buffer_x[tx] + a * buffer_y[tx];
		//y[i] = x[i] + a * y[i];
	}
}