/*
 *  kernels_single.h
 *  
 *
 *  Created by Olav Aanes Fagerlund.
 *
 */

#include "../../../../init/init_opencl.h"

double opencl_kernel_ddot(int n, cl_mem* x, cl_mem* y);

void opencl_kernel_daxpy(int n, double a, cl_mem *cl_d_x, cl_mem *cl_d_y);

void opencl_kernel_daypx(int n, double a, cl_mem *cl_d_x, cl_mem *cl_d_y);

void opencl_dcopy(int n, cl_mem* x, int incx, cl_mem* y, int incy);

void opencl_kernel_dscal(int n, double a, cl_mem* x);

void opencl_dspmv_bcsr(int rows, int cols, int nz, int r, int c, double alpha, cl_mem* ptr, 
					   cl_mem* idx, cl_mem* val, cl_mem* x, double beta, cl_mem* y);

void opencl_dspmv_bcsr4(int rows, int cols, int nz, int r, int c, double alpha, cl_mem* ptr, 
						cl_mem* idx, cl_mem* val, cl_mem* x, double beta, 
						cl_mem* y);

void opencl_dspmv_csr(int rows, int cols, int nz, double alpha, cl_mem* ptr, 
					  cl_mem* idx, cl_mem* val, cl_mem* x, double beta, 
					  cl_mem* y);

void opencl_dspmv_csr4(int rows, int cols, int nz, double alpha, cl_mem* ptr, 
					   cl_mem* idx, cl_mem* val, cl_mem* x, double beta, 
					   cl_mem* y);

void opencl_dspmv_hyb(int rows, int cols, int nz, double alpha, int ell_nz_row, int ell_stride, int csr_nz, 
					  cl_mem* d_ell_idx, cl_mem* d_ell_val, cl_mem* d_csr_ptr, cl_mem* d_csr_idx, cl_mem* d_csr_val,  
					  cl_mem* d_x, double beta, cl_mem* d_y);