/*
 *  kernels_single.h
 *  
 *
 *  Created by Olav Aanes Fagerlund.
 *
 */

#include "../../../../init/init_opencl.h"

double opencl_kernel_qdot(int n, cl_mem* xh, cl_mem* xt, cl_mem* yh, cl_mem* yt);

void opencl_kernel_qaxpy(int n, float a0, float a1, cl_mem* cl_xh, cl_mem* cl_xt, cl_mem* cl_yh, cl_mem* cl_yt);

void opencl_kernel_qaypx(int n, float a0, float a1, cl_mem* cl_xh, cl_mem* cl_xt, cl_mem* cl_yh, cl_mem* cl_yt);

void opencl_kernel_qscal(int n, float a0, float a1, cl_mem* xh, cl_mem* xt);

void opencl_qspmv_bcsr(int rows, int cols, int nz, int r, int c, double a0, double a1, cl_mem* ptr, 
					   cl_mem* idx, cl_mem* valh, cl_mem* valt, cl_mem* xh, cl_mem* xt, double b0, double b1, 
					   cl_mem* yh, cl_mem* yt);

void opencl_qspmv_bcsr4(int rows, int cols, int nz, int r, int c, double a0, double a1, cl_mem* ptr, 
						cl_mem* idx, cl_mem* valh, cl_mem* valt, 
						cl_mem* xh, cl_mem* xt, double b0, double b1, 
						cl_mem* yh, cl_mem* yt);

void opencl_qspmv_csr(int rows, int cols, int nz, double a0, double a1, cl_mem* ptr, 
					  cl_mem* idx, cl_mem* valh, cl_mem* valt, 
					  cl_mem* xh, cl_mem* xt, double b0, double b1, 
					  cl_mem* yh, cl_mem* yt);

void opencl_qspmv_csr4(int rows, int cols, int nz, double a0, double a1, cl_mem* ptr, 
					   cl_mem* idx, cl_mem* valh, cl_mem* valt, 
					   cl_mem* xh, cl_mem* xt, double b0, double b1, 
					   cl_mem* yh, cl_mem* yt);

void opencl_qspmv_hyb(int rows, int cols, int nz, float alpha0, float alpha1, int ell_nz_row, int ell_stride, int csr_nz, 
					  cl_mem* d_ell_idx, cl_mem* d_ell_valh, cl_mem* d_ell_valt, cl_mem* d_csr_ptr, cl_mem* d_csr_idx, cl_mem* d_csr_valh, cl_mem* d_csr_valt,  
					  cl_mem* d_xh, cl_mem* d_xt, float beta0, float beta1, cl_mem* d_yh, cl_mem* d_yt);