/*
 *  kernels_single.h
 *  
 *
 *  Created by Olav Aanes Fagerlund.
 *
 */

#include "../../../../init/init_opencl.h"

float opencl_kernel_sdot(int n, cl_mem* x, cl_mem* y);

void opencl_kernel_saxpy(int n, float a, cl_mem *cl_d_x, cl_mem *cl_d_y);

void opencl_kernel_saypx(int n, float a, cl_mem *cl_d_x, cl_mem *cl_d_y);

void opencl_scopy(int n, cl_mem* x, int incx, cl_mem* y, int incy);

void opencl_kernel_sscal(int n, float a, cl_mem* x);

void opencl_sspmv_bcsr(int rows, int cols, int nz, int r, int c, float alpha, cl_mem* ptr, 
					   cl_mem* idx, cl_mem* val, cl_mem* x, float beta, cl_mem* y);

void opencl_sspmv_bcsr4(int rows, int cols, int nz, int r, int c, float alpha, cl_mem* ptr, 
						cl_mem* idx, cl_mem* val, cl_mem* x, float beta, cl_mem* y);

void opencl_sspmv_csr(int rows, int cols, int nz, float alpha, cl_mem* d_ptr, 
					  cl_mem* d_idx, cl_mem* d_val, cl_mem* d_x, float beta, cl_mem* d_y);

void opencl_sspmv_csr4(int rows, int cols, int nz, float alpha, cl_mem* d_ptr, 
					   cl_mem* d_idx, cl_mem* d_val, cl_mem* d_x, float beta, cl_mem* d_y);

void opencl_sspmv_hyb(int rows, int cols, int nz, float alpha, int ell_nz_row, int ell_stride, int csr_nz, 
					  cl_mem* d_ell_idx, cl_mem* d_ell_val, cl_mem* d_csr_ptr, cl_mem* d_csr_idx, cl_mem* d_csr_val,  
					  cl_mem* d_x, float beta, cl_mem* d_y);