/*
 *  kernel_sscal.cl
 *  
 *
 *
 */

__kernel void kernel_sscal(
		const int n,    
		const float a,
		__global	 float* x,
		__local float* buffer_x
)
{
    // Starting point for this block
	int ctaStart = get_group_id(0) * get_local_size(0);
	 
	// Total no. of threads in the kernel
	int totalThreads = get_global_size(0);
	
	// Get current thread
	int tx = get_local_id(0);
	
	// Read the data (full lines)
	for (int i = ctaStart + tx; i < n; i += totalThreads)
	{  
		// Prefetch x
		buffer_x[tx] = x[i];
		
		// Scale and write
		x[i] = buffer_x[tx] * a;
		//x[i] = x[i] * a; 
	}
}