/**
 * @file blasx/blasx1_mp.h
 * @author Serban Georgescu
 * @since 2008
 *
 * Contains the extension of the
 * BLAS1 routines to MP vectors
 * 	
 */

#ifndef CUKR_BLASX1_MP_H_
#define CUKR_BLASX1_MP_H_

#include "../../mat_vec/vector.h"
#include "../../blas/blas.h"
#include "../blasx.h"

// ------------------------------------------------------------------- //

/**
/**
 * \brief Pointwise-product between
 *        two MP vectors
 * \param blas The BLAS structure
 * \param x,y The intput MP vectors
 * \param z The result MP vector 
 */
void CukrPWPR_MP(CUKR_BLAS blas, CUKR_VECTOR_MP x, CUKR_VECTOR_MP y, CUKR_VECTOR_MP z);


#endif /*CUKR_BLASX_H_MP_*/
