/**
 * @file init/init_cuda.cu
 * @author Serban Georgescu
 * @since 2008
 * 
 * The cuda-related initializations are
 * writen here, so that this file can be
 * compiled using the C++ compiler. 
 */

#include <stdio.h> 
#include <stdlib.h> 
#include <cuda.h>
#include <cutil.h>
#include "../cukr.h"


// ------------------------------------------------------------------- //

/**
 * \brief Do CUDA-related initializations and
 *        return the no. of GPUs in the system
 */
#ifdef __cplusplus
extern "C"
#endif 
int CukrInit_Cuda_cu()
{
	int gpuCount;
	
	/* Init devices */
	//CUT_DEVICE_INIT(0, NULL);
	
	/* Enumerate GPUs */
    CUDA_SAFE_CALL(cudaGetDeviceCount(&gpuCount));
    
    /* Return the no. of GPUs */
    return gpuCount;
}
