/*
 *  init_opencl.h
 *  
 *
 *  Created by Olav Aanes Fagerlund.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>

#ifdef __APPLE__
#include <OpenCL/cl.h>
#else
#include <CL/cl.h>
#endif


cl_context                       ComputeContext;
cl_command_queue                 ComputeCommands;

cl_kernel                        ComputeKernel_sdot;
cl_kernel                        ComputeKernel_qdot;
cl_kernel                        ComputeKernel_ddot;
cl_kernel                        ComputeKernel_saxpy;
cl_kernel                        ComputeKernel_qaxpy;
cl_kernel                        ComputeKernel_daxpy;
cl_kernel                        ComputeKernel_saypx;
cl_kernel                        ComputeKernel_qaypx;
cl_kernel                        ComputeKernel_daypx;
cl_kernel                        ComputeKernel_sscal;
cl_kernel                        ComputeKernel_qscal;
cl_kernel                        ComputeKernel_dscal;

cl_kernel						 ComputeKernel_sspmv_csr;
cl_kernel						 ComputeKernel_sspmv_csr_a1;
cl_kernel						 ComputeKernel_sspmv_csr_a1_b0;
cl_kernel						 ComputeKernel_sspmv_csr_b0;
cl_kernel						 ComputeKernel_sspmv_csr4;
cl_kernel						 ComputeKernel_sspmv_csr4_a1;
cl_kernel						 ComputeKernel_sspmv_csr4_a1_b0;
cl_kernel						 ComputeKernel_sspmv_csr4_b0;

cl_kernel						 ComputeKernel_qspmv_csr;
cl_kernel						 ComputeKernel_qspmv_csr_a1;
cl_kernel						 ComputeKernel_qspmv_csr_a1_b0;
cl_kernel						 ComputeKernel_qspmv_csr_b0;
cl_kernel						 ComputeKernel_qspmv_csr4;
cl_kernel						 ComputeKernel_qspmv_csr4_a1;
cl_kernel						 ComputeKernel_qspmv_csr4_a1_b0;
cl_kernel						 ComputeKernel_qspmv_csr4_b0;

cl_kernel						 ComputeKernel_dspmv_csr;
cl_kernel						 ComputeKernel_dspmv_csr_b0;
cl_kernel						 ComputeKernel_dspmv_csr4;
cl_kernel						 ComputeKernel_dspmv_csr4_b0;

cl_kernel						 ComputeKernel_sspmv_ell;
cl_kernel						 ComputeKernel_qspmv_ell;
cl_kernel						 ComputeKernel_dspmv_ell;

static cl_program				ComputeProgram;
static cl_platform_id		ComputePlatformId;
cl_device_id					ComputeDeviceId;

int AUTO_LOCAL_SIZE_SDOT;

int err;
cl_mem test;
cl_event	qdot_event,  sdot_event,  ddot_event,
			qaxpy_event, saxpy_event, daxpy_event,
			qaypx_event, saypx_event, daypx_event,
			qscal_event, sscal_event, dscal_event,
			scopy_event, dcopy_event,

			sspmv_csr_event, sspmv_csr_a1_b0_event, sspmv_csr_a1_event, sspmv_csr_b0_event,
			sspmv_csr4_event, sspmv_csr4_a1_b0_event, sspmv_csr4_a1_event, sspmv_csr4_b0_event,
			
			qspmv_csr_event, qspmv_csr_a1_b0_event, qspmv_csr_a1_event, qspmv_csr_b0_event,
			qspmv_csr4_event, qspmv_csr4_a1_b0_event, qspmv_csr4_a1_event, qspmv_csr4_b0_event,
			
			dspmv_csr_event, dspmv_csr_b0_event,
			dspmv_csr4_event, dspmv_csr4_b0_event,

			sspmv_hyb_event, qspmv_hyb_event, dspmv_hyb_event;
			 

static char * load_source(const char *filename);
int loadAndBuild(const char *filename, char *kernelname);
int CukrInit_OpenCL_cl();