/**
 * @file mat_vec/sp/bcsr/bcsr_matrix_sp_gen.h
 * @author Serban Georgescu
 * @since 2008
 *
 * Contains generators for creating various
 * types of synthetic matrices in BCSR format.
 */

#ifndef CUKR_BCSR_MATRIX_SP_GEN_H_
#define CUKR_BCSR_MATRIX_SP_GEN_H_

#include "../matrix_sp.h"

// ------------------------------------------------------------------- //
					 
/**
 * \brief Generates a sparse random matrix, filled
 *        with random elements
 * \param mat Pointer to the matrix 
 * \param nn Matrix order (Matrix size is nn x nn)
 * \param r,c Block sizes
 * \param name Matrix name
 */
void CukrBcsrMatspGenPoisson2D(CUKR_MATRIX_SP* mat, int nn, int r, int c, char* name);

/**
 * \brief Generates a sparse random matrix, filled
 *        with random elements
 * \param mat Pointer to the matrix 
 * \param nn Matrix order (Matrix size is nn x nn)
 * \param r,c Block sizes
 * \param name Matrix name
 */
void CukrBcsrMatspGenPoisson2Dsingle(CUKR_MATRIX_SP* mat, int nn, int r, int c, char* name);


#endif /*CUKR_BCSR_MATRIX_SP_GEN_H_*/
