/**
 * @file blas/gpu/cuda/kernels_config.h
 * @author Serban Georgescu
 * @since 2008
 * 
 * Contains configuration stuff for the
 * CUDA kernels (e.g. threads, blocks, etc).
 * 
 */

#ifndef CUKR_KERNELS_VECT_SP_CONFIG_H_
#define CUKR_KERNELS_VECT_SP_CONFIG_H_

/**
 * Double to qdouble 
 */
 
#define CUKR_COPY_DBL_QDBL_THREADS 256
#define CUKR_COPY_DBL_QDBL_CTAS    128
	 
/**
 * Double to single 
 */
 
#define CUKR_COPY_DBL_SNG_THREADS  256
#define CUKR_COPY_DBL_SNG_CTAS     128

/**
 * Qdouble to double 
 */
 
#define CUKR_COPY_QDBL_DBL_THREADS 256
#define CUKR_COPY_QDBL_DBL_CTAS    128 

/**
 * Single to double 
 */
 
#define CUKR_COPY_SNG_DBL_THREADS  256
#define CUKR_COPY_SNG_DBL_CTAS     128 

/*
 * Set in double
 */
 
#define CUKR_SET_DBL_VAL_THREADS  256
#define CUKR_SET_DBL_VAL_CTAS     128 

/*
 * Set in single
 */
 
#define CUKR_SET_SNG_VAL_THREADS  256
#define CUKR_SET_SNG_VAL_CTAS     128  

#endif /*CUKR_KERNELS_VECT_SP_CONFIG_H_ */
