/**
 * @file kernel_dbl_to_sng.h
 * @author Serban Georgescu
 * @since 2009
 * 
 * Defines a copy kernel.
 * 
 * The kernel copies a double precision data
 * vector to a quasi-double precision data vector.
 * 
 */
 
#include "kernels_config.h"

#ifndef _BX_TX
	#define _BX_TX
	#define tx          threadIdx.x 
	#define bx          blockIdx.x
#endif
/*
extern __shared__ double shared_d[];

__kernel void kernel_dbl_to_qdbl(const double *d_x, 
                                         float  *d_yh,
                                         float  *d_yt, 
                                   const int     n)
{	
	int i;
				
	// Alloc shared memory
	double *buffer = shared_d; 
	
	// Starting point for this block
	int ctaStart = bx * CUKR_COPY_DBL_QDBL_THREADS; 
	// Total no. of threads in the kernel
	int totalThreads = CUKR_COPY_DBL_QDBL_CTAS * CUKR_COPY_DBL_QDBL_THREADS;
	
	// Read and write the data
	for (i = ctaStart + tx; i < n; i += totalThreads)
	{  
		// Prefetch x and y
		buffer[tx] = d_x[i];
		
		// Write		 	 
		d_yh[i] = buffer[tx];
		d_yt[i] = buffer[tx] - (float)buffer[tx];
	}  
	 
}

*/