/**
 * @file pc/jacobi_pc.h
 * @author Serban Georgescu
 * @since 2008
 * 
 * Defines the actual implementation
 * of the Jacobi type preconditioner 
 * 
 * The solver is written using the
 * abstract BLAS interface, therefore
 * it runs both on CPU, GPU or using
 * both in combination.
 */

#ifndef CUKR_JACOBI_PC_H_
#define CUKR_JACOBI_PC_H_

#include "../pc.h"

/**
 * Define Jacobi preconditioner data
 * holder format */
typedef struct _JACOBI_PC_DATA {
	/** Hold the inverse of the diagonal
	 * of the matrix */
	CUKR_VECTOR invdiag;
} *JACOBI_PC_DATA;

/** 
 * \brief Bind the Jacobi prec to the
 *        preconditioner context
 * \param pc The prec. context
 */
void pc_create_jacobi(CUKR_PC pc);
 

#endif /*CUKR_JACOBI_PC_H_*/
