/**
 * @file log.c
 * @author Serban Georgescu
 * @since 2007
 *
 * This is a wrapper for the logging
 * mechanism provided by the log4.c libray.
 * 
 * We simply wrap the logging routines in
 * macros out of lazyness.
 * 	
 */

#include "log.h"
#include <stdlib.h>
 
/**
 *  \brief Logging a message to the specified
 *         category.
 * 
 *  \param loggerName the logger name
 *  \param level logging priority
 *  \param msg the actual message
 */
void
Log (char *loggerName, int level, char* msg, char* file, int line)
{
	/* If fatal, use printf and exit */
	if (level == FATAL) {
		printf("FATAL: [%s] %s @ file %s:%d\n", loggerName, msg, file, line);
		exit(1);
	}
}
