/************************************************
*                                               *
* KrSolve - macros.h		 	                *
* 												*
* Various useful macros							*
*        										*
************************************************/

#ifndef MACROS_H_
#define MACROS_H_

#include <sys/time.h>
#include <sys/timeb.h>

/**
 * Starts the clock 
 */
#define CLOCK_START  gettimeofday(&t_start,  &t_zone);
#define CLOCK_START2 gettimeofday(&t_start2, &t_zone);
/**
 * Stops the clock 
 */
#define CLOCK_END   gettimeofday(&t_end,  &t_zone);
#define CLOCK_END2  gettimeofday(&t_end2, &t_zone);
/**
 * Return the time elapsed between CLOCK_START
 * and CLOCK_STOP (in msec)
 */
#define CLOCK_SPAN  (t_end.tv_usec*0.001  - t_start.tv_usec*0.001)  + 1000*(t_end.tv_sec  - t_start.tv_sec);
#define CLOCK_SPAN2 (t_end2.tv_usec*0.001 - t_start2.tv_usec*0.001) + 1000*(t_end2.tv_sec - t_start2.tv_sec);
 

/**
 *  Macro for printing an int variable 
 */
#define PRINT_I(var) printf(#var " = %d\n", var)

/**
 *  Macro for printing a float variable 
 **/
#define PRINT_F(var) printf(#var " = %g\n", var)


#endif /*MACROS_H_*/
