/**
 * @file utils/utils.h
 * @author Serban Georgescu
 * @since 2008
 * 
 * Defines various functions, useful
 * throughout the implementation
*/

#define LOGGER_NAME "CUKr.util.utils_cuda"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <cuda.h>
#include <cutil.h>

/**
 * \brief Wrapper for the cudaSetDevice 
 *        function
 * \param gpuid The id of the GPU to set
 */
#ifdef __cplusplus
extern "C"
#endif 
void CukrSetDevice_cu(int gpuid)
{
	/* Set the device cu gpuid */
	CUDA_SAFE_CALL(cudaSetDevice(gpuid));
	
	cudaDeviceProp deviceProp;
	cudaGetDeviceProperties(&deviceProp, gpuid);
	printf("\nThread %d \"%s\"\n", gpuid, deviceProp.name);
}

